/*
** add.c for pv in /home/saf/pv/src
** 
** Made by Stephan Ferraro
** Login   <saf@xy1.org>
** 
** Started on  Thu Feb 12 01:25:57 2004 Stephan Ferraro
** Last update Thu Feb 12 03:50:04 2004 Stephan Ferraro
** 
** This program is free software; you can redistribute it and/or
** modify it under the terms of the GNU Library General Public
** License as published by the Free Software Foundation; either
** version 2 of the License, or (at your option) any later version.
**
** This library is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
** Library General Public License for more details.
** 
** You should have received a copy of the GNU Library General Public
** License along with this library; if not, write to the Free
** Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include	"pv.h"

/* Add files in the current list, and update all informations */
/* (for example by saving images to PNG files) */

void		add_file_id(t_pv *p, char *new_filename)
{
  char		**new;
  int		i;

  new = xmalloc((p->files_nb + 2) * sizeof(char *));
  for (i = 0; i < p->current_file_id; i++)
    new[i] = strdup(p->filenames[i]);
  new[i] = new_filename;
  for (i = p->current_file_id + 1; i < p->files_nb + 1; i++)
    new[i] = strdup(p->filenames[i - 1]);
  new[i] = 0;
  if (p->filenames_alloc)
    free(p->filenames);
  p->filenames = new;
  p->multiple_files = 1; /* we must switch to multiple file mode in all cases */
  p->filenames_alloc = 1; /* we used malloc, so next time we need to free */
}

void		add_to_filelist(t_pv *p, char *filename)
{
  add_file_id(p, filename);
  p->filename = filename;
  p->files_nb += 1;
  aff_current_file(p);
  aff_fileinfotext(p);
}
