/*
** aff_fileinfotext.c for pv in /home/saf/pv
** 
** Made by Stephan Ferraro
** Login   <saf@xy1.org>
** 
** Started on  Fri Jan  9 00:44:45 2004 Stephan Ferraro
** Last update Wed May 12 16:58:48 2004 Debian User
** 
** This program is free software; you can redistribute it and/or
** modify it under the terms of the GNU Library General Public
** License as published by the Free Software Foundation; either
** version 2 of the License, or (at your option) any later version.
**
** This library is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
** Library General Public License for more details.
** 
** You should have received a copy of the GNU Library General Public
** License along with this library; if not, write to the Free
** Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include	"pv.h"

int		press_text_key(t_pv *p)
{
  if (p->text_screen)
    {
      p->text_screen = 0;
      aff_current_file(p);
    }
  else
    {
      p->text_screen = 1;
      aff_fileinfotext(p);
      SDL_UpdateRect(p->screen, 0, 0, p->screen->w, p->screen->h);
    }
  return (0);
}

void		init_pv_font(t_pv *p)
{
  if (TTF_Init() < 0)
    {
      fprintf(stderr, "Couldn't initialize TTF: %s\n", SDL_GetError());
      exit(1);
    }
  p->font_rw = SDL_RWFromMem(gl_bin_font_data, sizeof(gl_bin_font_data));
  if (!p->font_rw)
    err_msg("SDL_RWFromMem");
  p->font = TTF_OpenFontRW(p->font_rw, 1, FONT_SIZE);
  if (!p->font)
    {
      fprintf(stderr, "TTF_OpenFontRW\n");
      err_msg(SDL_GetError());
    }
  TTF_SetFontStyle(p->font, TTF_STYLE_NORMAL);
}

void		aff_fileinfotext(t_pv *p)
{
  SDL_Color	white = { 0xFF, 0xFF, 0xFF, 0 };
  char		buffer[4096];

  
  sprintf(buffer, "%.3800s", p->filename);
  print_text(p, buffer, 2, 2, &white);

  if (p->auto_resize)
    {
      sprintf(buffer, "[%d / %d] %dx%d:%d (%.2f%%)",
	      p->current_file_id + 1, p->files_nb,
	      p->img_file->w,p->img_file->h,
	      p->img_file->format->BitsPerPixel,
	      p->real_zoom);
    }
  else
    sprintf(buffer, "[%d / %d] %dx%d:%d",
	    p->current_file_id + 1, p->files_nb,
	    p->img_file->w,p->img_file->h,
	    p->img_file->format->BitsPerPixel);
  print_text(p, buffer, 2, 20, &white);
}

void		print_text(t_pv *p, char *ttf_text, int x, int y, SDL_Color *color)
{
  SDL_Rect	dstrect;
  char		buffer[4096];
  SDL_Color	black = { 0x00, 0x00, 0x00, 100 };

  sprintf(buffer, "%.3800s", ttf_text);
  p->font_surface = TTF_RenderText_Blended(p->font, buffer, black);
  if (!p->font_surface)
    {
      fprintf(stderr, "TTF_RenderText_Solid\n");
      err_msg(SDL_GetError());
    }
  dstrect.x = x + 1;
  dstrect.y = y + 1;
  dstrect.w = p->font_surface->w;
  dstrect.h = p->font_surface->h;
  SDL_BlitSurface(p->font_surface, NULL, p->screen, &dstrect);
  SDL_FreeSurface(p->font_surface);
  p->font_surface = TTF_RenderText_Blended(p->font, buffer, *color);
  if (!p->font_surface)
    {
      fprintf(stderr, "TTF_RenderText_Solid\n");
      err_msg(SDL_GetError());
    }
  dstrect.x = x;
  dstrect.y = y;
  dstrect.w = p->font_surface->w;
  dstrect.h = p->font_surface->h;
  SDL_BlitSurface(p->font_surface, NULL, p->screen, &dstrect);
  SDL_FreeSurface(p->font_surface);
}
