/*
** aff_image.c for pv in /home/saf/pv
** 
** Made by Stephan Ferraro
** Login   <saf@xy1.org>
** 
** Started on  Sun Dec 28 20:02:56 2003 Stephan Ferraro
** Last update Tue Sep 14 22:44:09 2004 Stephan Ferraro
** 
** This program is free software; you can redistribute it and/or
** modify it under the terms of the GNU Library General Public
** License as published by the Free Software Foundation; either
** version 2 of the License, or (at your option) any later version.
**
** This library is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
** Library General Public License for more details.
** 
** You should have received a copy of the GNU Library General Public
** License along with this library; if not, write to the Free
** Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include	"pv.h"

void		center_scroll_picture(t_pv *p, int img_w, int img_h)
{
  int		tmp;

  if (img_w < p->win_w)
    {
      tmp = ((p->win_w) - (img_w)) / 2;
      p->scroll_rect.x += tmp;
    }
  if (img_h < p->win_h)
    {
      tmp = ((p->win_h) - (p->img_file->h)) / 2;
      p->scroll_rect.y += tmp;
    }
}

/* Don't know why SDL deletes the contents of SDL_Rect with the blit function. */
/* I make a copy of it. */
void		aff_image(t_pv *p)
{
  SDL_Rect	save;

  memcpy(&save, &(p->scroll_rect), sizeof(SDL_Rect));
  if (p->rotate == 90 || p->rotate == 270)
    center_scroll_picture(p, p->img_file->h, p->img_file->w);
  else
    center_scroll_picture(p, p->img_file->w, p->img_file->h);
  put_black_background(p);
  if (p->rotate > 0)
    {
      SDL_Surface	*zoom;
      
      if ((zoom = rotozoomSurface(p->img_file,
				  (float)p->rotate,
				  1.0,
				  SMOOTHING_OFF)) == NULL)
	err_msg_function("rotozoomSurface");
      if (SDL_BlitSurface(zoom, 0, p->screen, &(p->scroll_rect)) <= -1)
	err_msg_function("SDL_BlitSurface");
    }
  else
    if (SDL_BlitSurface(p->img_file, 0, p->screen, &(p->scroll_rect)) <= -1)
      err_msg_function("SDL_BlitSurface");
  if (p->text_screen)
    aff_fileinfotext(p);
  if (p->help_screen)
    aff_help_text(p);
  memcpy(&(p->scroll_rect), &save, sizeof(SDL_Rect));

  SDL_UpdateRect(p->screen, 0, 0, p->screen->w, p->screen->h);

/*   Here the Benchmark test finish */
  if (p->benchmark.activated)
    {
      benchmark_stop(p);
      benchmark_result(p);
      exit(0);
    }
}

void		aff_current_file(t_pv *p)
{
  if (p->auto_resize)
    {
	autoresize(p, p->win_w, p->win_h, p->img_file->w, p->img_file->h);
	init_caption(p);
    }
  else
    {
      init_caption(p);
      aff_image(p);
    }
}

int		switch_auto_resize(t_pv *p)
{
  if (p->auto_resize)
    {
      p->auto_resize = 0;
      p->zoom = 100; /* 100% zoom without autorezing */
    }
  else
    p->auto_resize = 1;
  aff_current_file(p);
  return (0);
}
