/*
** check_arguments.c for pv in /home/saf/pv
** 
** Made by Stephan Ferraro
** Login   <saf@xy1.org>
** 
** Started on  Wed Jan 28 21:25:18 2004 Stephan Ferraro
** Last update Tue Sep 14 22:24:41 2004 Stephan Ferraro
** 
** This program is free software; you can redistribute it and/or
** modify it under the terms of the GNU Library General Public
** License as published by the Free Software Foundation; either
** version 2 of the License, or (at your option) any later version.
**
** This library is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
** Library General Public License for more details.
** 
** You should have received a copy of the GNU Library General Public
** License along with this library; if not, write to the Free
** Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include	"pv.h"

void		aff_copyright()
{
  printf("Unix Picture Viewer (SDL/X11)\n");
  printf("Version %d.%d.%d unstable\n\n",
	 VERSION_MAJOR, VERSION_MINOR, VERSION_MICRO);
  printf("Made by Stephan Ferraro, 2004 at Paris, Stuttgart - France, Germany.\n");
  printf("For comments or sugesstions, please write me an email to: ferrar_s@epitech.net\n");
}

void		check_arguments(t_pv *p, int ac, char **av)
{
  char		ch;

  while ((ch = getopt(ac, av, "bdxvh?")) != -1)
    {
      switch (ch)
	{
	case 'b':
	  p->benchmark.activated = 1;
	  break;
	case 'x':
	  p->xfe_mode = 1;
	  break;
	case 'v':
	  aff_copyright(av[0]);
          exit(0);
	case 'd':
	  p->verbose = 1;
	  break;
	case 'h':
	case '?':
	  usage(av[0]);
	  printf("\n");
	  aff_copyright();
	  printf("\nTo show pictures, type: $ pv filename\n");
	  printf("Example: $ pv image1.jpg\n\n");
	  printf("You can also show more than one picture by giving more than one argument.\n");
	  printf("Example: $ pv *.jpg test.png\n\n");
	  printf("Hit the \"h\" key to get online help in the program.\n");
	  exit(0);
	}
    }
  p->ac = ac - optind;
  p->av = av + optind;
}
