/*
** fullscreen.c for pv in /home/saf/pv
** 
** Made by Stephan Ferraro
** Login   <saf@xy1.org>
** 
** Started on  Sun Dec 28 23:56:05 2003 Stephan Ferraro
** Last update Thu Feb  5 23:01:40 2004 Stephan Ferraro
** 
** This program is free software; you can redistribute it and/or
** modify it under the terms of the GNU Library General Public
** License as published by the Free Software Foundation; either
** version 2 of the License, or (at your option) any later version.
**
** This library is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
** Library General Public License for more details.
** 
** You should have received a copy of the GNU Library General Public
** License along with this library; if not, write to the Free
** Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include	"pv.h"

int		fullscreen(t_pv *p)
{
  if (!p->fullscreen)
    {
      SDL_FreeSurface(p->screen);
      p->screen = SDL_SetVideoMode(p->wm_w,
				   p->wm_h,
				   p->img_file->format->BitsPerPixel,
				   SDL_SWSURFACE | SDL_FULLSCREEN);
      p->win_h = p->wm_h;
      p->win_w = p->wm_w;
      if (p->auto_resize)
	autoresize(p, p->win_w, p->win_h, p->img_file->w, p->img_file->h);
      else
	aff_image(p);
      p->fullscreen = 1;
    }
  else
    {
      SDL_FreeSurface(p->screen);
      p->fullscreen = 0;
      p->screen = SDL_SetVideoMode(p->win_w,
				   p->win_h,
				   p->img_file->format->BitsPerPixel,
				   SDL_SWSURFACE | SDL_RESIZABLE);
      if (p->auto_resize)
	autoresize(p, p->win_w, p->win_h, p->img_file->w, p->img_file->h);
      else
	aff_image(p);
    }
  return (0);
}
