/*
** help.c for pv in /home/saf/pv
** 
** Made by Stephan Ferraro
** Login   <saf@xy1.org>
** 
** Started on  Wed Jan 28 22:12:09 2004 Stephan Ferraro
** Last update Tue May 11 20:00:34 2004 Stephan Ferraro
** 
** This program is free software; you can redistribute it and/or
** modify it under the terms of the GNU Library General Public
** License as published by the Free Software Foundation; either
** version 2 of the License, or (at your option) any later version.
**
** This library is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
** Library General Public License for more details.
** 
** You should have received a copy of the GNU Library General Public
** License along with this library; if not, write to the Free
** Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include	"pv.h"

int		press_help_key(t_pv *p)
{
  if (p->help_screen)
    {
      p->help_screen = 0;
      aff_current_file(p);
    }
  else
    {
      p->help_screen = 1;
      aff_help_text(p);
      SDL_UpdateRect(p->screen, 0, 0, p->screen->w, p->screen->h);
    }
  return (0);
}

#define	LEFT	80
#define UP_HELP	100

char		*gl_menu[]=
  {
    "Unix Picture Viewer",
    "f / Enter / F11: Fullscreen",
    "h / F1: Online help (this help)",
    "r: Rotate 90 degree",
    "s: Save image as PNG file",
    "t: Text on/off",
    "z: Autoresize On / Off",
    "+: Zoom in",
    "-: Zoom out",
    "ESC / q: Quit the programm",
    "Page up / p: Previous file",
    "Page down / Spacebar / n: Next file",
    "Home: First file",
    "End: Last file",
    0
  };

void		aff_help_text(t_pv *p)
{
  SDL_Color	yellow = { 0xFF, 0xFF, 0x00, 0 };
  int		i;

  for (i = 0; gl_menu[i]; i++)
    print_text(p,
	       gl_menu[i],
	       (p->screen->w / 2) - LEFT,
	       (p->screen->h / 2) - UP_HELP + (i * 20),
	       &yellow);
}
