/*
** init_video.c for pv in /home/saf/pv
** 
** Made by Stephan Ferraro
** Login   <saf@xy1.org>
** 
** Started on  Sat Dec 27 18:16:16 2003 Stephan Ferraro
** Last update Wed Jul  7 12:38:56 2004 Stephan Ferraro
** 
** This program is free software; you can redistribute it and/or
** modify it under the terms of the GNU Library General Public
** License as published by the Free Software Foundation; either
** version 2 of the License, or (at your option) any later version.
**
** This library is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
** Library General Public License for more details.
** 
** You should have received a copy of the GNU Library General Public
** License along with this library; if not, write to the Free
** Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include	"pv.h"

void		init_video_lib(t_pv *p)
{
  if (SDL_Init(SDL_INIT_VIDEO | SDL_INIT_EVENTTHREAD) < 0 )
    {
      fprintf(stderr, "Unable to init SDL: %s\n", SDL_GetError());
      exit(1);
    }
  atexit(SDL_Quit);
}

void		init_video(t_pv *p, int w, int h, int bits)
{
  p->screen = SDL_SetVideoMode(w,
			       h,
			       bits,
			       SDL_HWSURFACE | SDL_RESIZABLE);
  if (p->screen == NULL)
    {
      fprintf(stderr, "Unable to set %dx%d video: %s\n", w, h, SDL_GetError());
      exit(1);
    }
  aff_loading_caption();
  p->win_w = p->screen->w;
  p->win_h = p->screen->h;
}
