/*
** keyboard.c for pv in /home/saf/pv
** 
** Made by Stephan Ferraro
** Login   <saf@xy1.org>
** 
** Started on  Tue Dec 30 04:44:02 2003 Stephan Ferraro
** Last update Mon Jun 14 19:04:59 2004 Stephan Ferraro
** 
** This program is free software; you can redistribute it and/or
** modify it under the terms of the GNU Library General Public
** License as published by the Free Software Foundation; either
** version 2 of the License, or (at your option) any later version.
**
** This library is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
** Library General Public License for more details.
** 
** You should have received a copy of the GNU Library General Public
** License along with this library; if not, write to the Free
** Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include	"pv.h"

/* Handle_keyboard is not the correct name of the function, */
/*   because we handle also video resize and quit mask, I will rename it later. */

#define		EVENTS_NUM	10

int		handle_keyboard(void *pt)
{
  SDL_Event	events[EVENTS_NUM];
  int		i;
  int		found;
  Uint32	mask;
  t_pv		*p;

  p = pt;
  mask = (SDL_KEYDOWNMASK | SDL_KEYUPMASK | SDL_VIDEORESIZEMASK | SDL_QUITMASK);
  while (!p->done)
    {
      found = SDL_PeepEvents(events, EVENTS_NUM, SDL_GETEVENT, mask);
      for (i = 0; i < found; ++i)
	{
	  p->event = &events[i];
	  if (manage_event(p) == -1)
	    {
	      p->done = 1;
	      return (-1);
	    }
	  }
	}
  return (0);
}
