/*
** load_image.c for pv in /home/saf/pv/src
** 
** Made by Stephan Ferraro
** Login   <saf@xy1.org>
** 
** Started on  Mon Jun 14 19:07:49 2004 Stephan Ferraro
** Last update Tue Aug 10 17:12:29 2004 
** 
** This program is free software; you can redistribute it and/or
** modify it under the terms of the GNU Library General Public
** License as published by the Free Software Foundation; either
** version 2 of the License, or (at your option) any later version.
**
** This library is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
** Library General Public License for more details.
** 
** You should have received a copy of the GNU Library General Public
** License along with this library; if not, write to the Free
** Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include	"pv.h"

int		load_image(t_pv *p)
{
  static char	*old_filename = 0;
  SDL_Surface	*new_file;

  if (!old_filename || old_filename != p->filename)
    {
      if (p->multiple_files)
	if (p->filename == p->filenames[p->best_file_id])
	  return (-1);
      old_filename = p->filename;

/* Benchmark test with one single image file */
      if (p->benchmark.activated)
	{
	  benchmark_start(p);
	  new_file = IMG_Load(p->filename);
	  if (!new_file)
	    {
	      fprintf(stderr, "pv: %s file format not supported.\n", p->filename);
	      exit(1);
	    }
	}

      new_file = IMG_Load(p->filename);
      if (!new_file)
	{
	  if (p->multiple_files)
	    return (-1);
	  fprintf(stderr, "pv: %s file format not supported.\n", p->filename);
	  fprintf(stderr, "pv currently supports only BMP, PNM (PPM/PGM/PBM), XPM, LBM, PCX, GIF, JPEG, PNG, TGA, and TIFF file formats.\n");
	  exit(1);
	}
      if (p->img_file)
	SDL_FreeSurface(p->img_file);
      p->img_file = new_file;
      if (p->img_file->format->palette && p->screen->format->palette)
	{
	  SDL_SetColors(p->screen, p->img_file->format->palette->colors, 0,
			p->img_file->format->palette->ncolors);
	}
      return (0);
    }
  return (0); /* didn't reload pic and don't return other val than 0, or program will segfault */
}
