/*
** main_loop.c for pv in /home/saf/pv
** 
** Made by Stephan Ferraro
** Login   <saf@xy1.org>
** 
** Started on  Sun Dec 28 20:33:27 2003 Stephan Ferraro
** Last update Tue Jun 15 16:05:29 2004 Stephan Ferraro
** 
** This program is free software; you can redistribute it and/or
** modify it under the terms of the GNU Library General Public
** License as published by the Free Software Foundation; either
** version 2 of the License, or (at your option) any later version.
**
** This library is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
** Library General Public License for more details.
** 
** You should have received a copy of the GNU Library General Public
** License along with this library; if not, write to the Free
** Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include	"pv.h"

t_key		gl_general_keys[]=
  {
    {SDLK_f, fullscreen},
    {SDLK_RETURN, fullscreen},
    {SDLK_z, switch_auto_resize},
    {SDLK_y, switch_auto_resize}, /* if there are keyboard zone conflicts */
    {SDLK_RIGHT, press_right},
    {SDLK_DOWN, press_down},
    {SDLK_LEFT, press_left},
    {SDLK_UP, press_up},
    {SDLK_r, press_rotate_key},
    {SDLK_s, press_save_key},
    {SDLK_t, press_text_key},
    {SDLK_HOME, aff_first_file},
    {SDLK_END, aff_last_file},
    {SDLK_F1, press_help_key},
    {SDLK_h, press_help_key},
    {SDLK_F11, fullscreen},
    {SDLK_PLUS, press_zoom_in},
    {SDLK_MINUS, press_zoom_out},
    {SDLK_KP_PLUS, press_zoom_in},
    {SDLK_KP_MINUS, press_zoom_out},
    {0, 0}
  };

t_key		gl_multi_files_keys[]=
  {
    {SDLK_SPACE, press_next_file},
    {SDLK_PAGEDOWN, press_next_file},
    {SDLK_n, press_next_file},
    {SDLK_BACKSPACE, press_previous_file},
    {SDLK_PAGEUP, press_previous_file},
    {SDLK_p, press_previous_file},
    {0, 0}
  };

t_key		gl_general_keys_up[]=
  {
    {SDLK_BACKSPACE, unpress_switch_image},
    {SDLK_PAGEUP, unpress_switch_image},
    {SDLK_p, unpress_switch_image},
    {SDLK_SPACE, unpress_switch_image},
    {SDLK_PAGEDOWN, unpress_switch_image},
    {SDLK_n, unpress_switch_image},
    {SDLK_RIGHT, unpress_right},
    {SDLK_DOWN, unpress_down},
    {SDLK_LEFT, unpress_left},
    {SDLK_UP, unpress_up},
    {SDLK_PLUS, unpress_stop_zoom},
    {SDLK_MINUS, unpress_stop_zoom},
    {SDLK_KP_PLUS, unpress_stop_zoom},
    {SDLK_KP_MINUS, unpress_stop_zoom},
    {0, 0}
  };

/* We use pointer function to tries to keep up a clean C source code. */
int		manage_event(t_pv *p)
{
  int		i;

  if (p->event->type == SDL_KEYUP)
    {
      for (i = 0; gl_general_keys_up[i].key; i++)
	if (gl_general_keys_up[i].key == p->event->key.keysym.sym)
	  return (gl_general_keys_up[i].f(p));
    }
  if (p->event->type == SDL_KEYDOWN)
    {
      if (p->event->key.keysym.sym == SDLK_ESCAPE ||
	  (p->event->key.keysym.sym == SDLK_q))
	return (-1); /* Exit program */
      for (i = 0; gl_general_keys[i].key; i++)
	if (gl_general_keys[i].key == p->event->key.keysym.sym)
	  return (gl_general_keys[i].f(p));
      if (p->multiple_files)
	{
	  for (i = 0; gl_multi_files_keys[i].key; i++)
	    if (gl_multi_files_keys[i].key == p->event->key.keysym.sym)
	      return (gl_multi_files_keys[i].f(p));
	}
    }
  if (p->event->type == SDL_QUIT)
    return (-1);
  if (p->event->type == SDL_VIDEORESIZE)
    {
      resize_window_event(p);
      return (0);
    }
  return (0);
}

void		main_loop(t_pv *p)
{
  /* Loop, waiting for QUIT */
  while (!p->done)
    {
      if (SDL_PeepEvents(NULL, 0, SDL_PEEKEVENT, SDL_QUITMASK))
	{
	  p->done = 1;
	}
      scroll_test_if_key_press(p);
      zoom_if_key_press(p);
      next_image_if_key_press(p);
      /* Give up some CPU so the events can accumulate */
      SDL_Delay(20);
    }
}
