/*
** proto.h for pv in /home/saf/privat/pv/src
** 
** Made by Stephan Ferraro
** Login   <saf@xy1.org>
** 
** Started on  Mon Jun 14 18:27:18 2004 Stephan Ferraro
** Last update Tue Aug 10 16:36:26 2004 
*/

/* found in init_video.c */
void		init_video_lib(t_pv *p);
void		init_video(t_pv *p, int w, int h, int bits);

/* found in pv.c */
void		pv_one_file(t_pv *p, char **filenames);
void		pv_multiple_files(t_pv *p, int nb, char **filenames);
void		pv(int ac, char **av);

/* found in load_image.c */
int		load_image(t_pv *p);

/* found in main_loop.c */
int		manage_event(t_pv *p);
void		main_loop(t_pv *p);

/* found in add.c */
void		add_file_id(t_pv *p, char *new_filename);
void		add_to_filelist(t_pv *p, char *filename);

/* found in resize.c */
void		autoresize(t_pv *p, int w, int h, int img_w, int img_h);
void		resize_window_event(t_pv *p);
int		get_zoom_ratio(t_pv *p, int w, int h, int img_w, int img_h);

/* found in aff_image.c */
void		center_scroll_picture(t_pv *p, int img_w, int img_h);
void		aff_image(t_pv *p);
void		aff_current_file(t_pv *p);
int		switch_auto_resize(t_pv *p);

/* found in textmode.c */
void		aff_fileinfo(char *filename, SDL_Surface *img_file);

/* found in get_wm_property.c */
void			get_wm_property(t_pv *p);

/* found in xmalloc.c */
void            *xmalloc(unsigned int size);

/* found in fullscreen.c */
int		fullscreen(t_pv *p);

/* found in scroll.c */
int		init_scroll(t_pv *p);
int		check_scroll_direction(t_pv *p, int direction);
int		press_down(t_pv *p);
int		press_up(t_pv *p);
int		press_right(t_pv *p);
int		press_left(t_pv *p);
int		unpress_down(t_pv *p);
int		unpress_up(t_pv *p);
int		unpress_right(t_pv *p);
int		unpress_left(t_pv *p);
int		aff_scroll_down(t_pv *p);
int		aff_scroll_up(t_pv *p);
int		aff_scroll_left(t_pv *p);
int		aff_scroll_right(t_pv *p);
int		aff_scroll_by_mouse(t_pv *p);
int		scroll_test_if_key_press(t_pv *p);

/* found in mouse.c */
int		handle_mouse(void *pt);

/* found in help.c */
int		press_help_key(t_pv *p);
void		aff_help_text(t_pv *p);

/* found in main.c */
int		main(int ac, char **av);

/* found in aff_fileinfotext.c */
int		press_text_key(t_pv *p);
void		init_pv_font(t_pv *p);
void		aff_fileinfotext(t_pv *p);
void		print_text(t_pv *p, char *ttf_text, int x, int y, SDL_Color *color);

/* found in rotate.c */
int		press_rotate_key(t_pv *p);

/* found in save.c */
void		init_save_file(t_save *save, t_pv *p);
void		init_png_header(t_save *save, t_pv *p);
t_uchar		*convert_32bits_to_24bits(t_uchar *pixels, t_uint w, t_uint h);
void		init_png_save_core(t_save *save, t_pv *p);
int		press_save_key(t_pv *p);

/* found in multiple_files.c */
void		init_multiple_file(t_pv *p);
void		check_and_put_best_filename(t_pv *p, int ret);
int		next_file(t_pv *p);
int		previous_file(t_pv *p);
int		aff_next_file(t_pv *p);
int		aff_previous_file(t_pv *p);
int		aff_first_file(t_pv *p);
int		aff_last_file(t_pv *p);
int		press_previous_file(t_pv *p);
int		press_next_file(t_pv *p);
int		unpress_switch_image(t_pv *p);
int		next_image_if_key_press(t_pv *p);

/* found in check_arguments.c */
void		aff_copyright();
void		check_arguments(t_pv *p, int ac, char **av);

/* found in usage.c */
void		usage(char *prog_name);

/* found in put_black_background.c */
void		put_black_background(t_pv *p);

/* found in err_msg.c */
void		err_msg(char *text);
void		err_msg_function(char *text);
void		err_msg_sdl(char *text);
void		err_msg_perror(char *str);

/* found in zoom.c */
int		press_zoom_in(t_pv *p);
int		press_zoom_out(t_pv *p);
int		unpress_stop_zoom(t_pv *p);
int		zoom_out(t_pv *p);
int		zoom_in(t_pv *p);
int		zoom_if_key_press(t_pv *p);

/* found in pv_font.c */

/* found in keyboard.c */
int		handle_keyboard(void *pt);

/* found in init_caption.c */
void		init_caption(t_pv *p);
void            aff_loading_caption();

/* found in load_directory.c */
void		load_directory_files(t_pv *p);

/* found in benchmark.c */
void		benchmark_start(t_pv *p);
void		benchmark_stop(t_pv *p);
void		benchmark_result(t_pv *p);
