/*
** pv.c for pv in /home/saf/pv
** 
** Made by Stephan Ferraro
** Login   <saf@xy1.org>
** 
** Started on  Sat Dec 27 18:12:08 2003 Stephan Ferraro
** Last update Tue Sep 14 22:42:18 2004 Stephan Ferraro
** 
** This program is free software; you can redistribute it and/or
** modify it under the terms of the GNU Library General Public
** License as published by the Free Software Foundation; either
** version 2 of the License, or (at your option) any later version.
**
** This library is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
** Library General Public License for more details.
** 
** You should have received a copy of the GNU Library General Public
** License along with this library; if not, write to the Free
** Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include	"pv.h"

void		pv_multiple_files(t_pv *p, int nb, char **filenames)
{
  p->fullscreen = 0;
  p->auto_resize = 0;
  p->multiple_files = 1;
  p->filenames = filenames;
  p->filenames_alloc = 0;
  p->files_nb = nb;
  p->best_file_id = -1;
  init_video_lib(p);
/*   Minimize a little the picture to be good centered with any window manager */
  get_wm_property(p);

/*   Load image file */
  next_file(p);

/*   Create SDL X11 Window */
/*   If XFE mode we open a window already resized for the current window manager. */
  if (p->xfe_mode)
    init_video(p, p->wm_w - 100, p->wm_h - 100, 0);
  else
    init_video(p, p->img_file->w, p->img_file->h, p->img_file->format->BitsPerPixel);


  if (p->auto_resize)
    autoresize(p, p->win_w, p->win_h, p->img_file->w, p->img_file->h);
  else
    aff_image(p);
  init_caption(p);
  main_loop(p);
  SDL_FreeSurface(p->img_file);
}

void		pv(int ac, char **av)
{
  t_pv		p;
  SDL_Thread	*mouse_thread;
  SDL_Thread	*keyboard_thread;

  memset(&p, 0, sizeof(t_pv));
  check_arguments(&p, ac, av);
  p.wait_first_cyl = WAIT_FIRST_IMAGE;
  p.wait_zoom_cyl = WAIT_FIRST_ZOOM;
  p.done = 0;
  p.zoom = 100; /* 100% zoom per default */
  /* Create the event handling threads */
  mouse_thread = SDL_CreateThread(handle_mouse, (void *)&p);
  keyboard_thread = SDL_CreateThread(handle_keyboard, (void *)&p);
  if (!mouse_thread || !keyboard_thread)
    {
      err_msg_sdl("SDL_CreateThread");
    }
  init_pv_font(&p);
  p.text_screen = 1;
  p.current_file_id = -1;
  if (p.xfe_mode || p.ac == 0) /* only if we are in xfe mode or no arguments */
    {
      load_directory_files(&p); /* one file argument, sets file pointer to current file */
      pv_multiple_files(&p, p.ac, p.av);
    }
  else
    { /* Load only one file to view */
      p.current_file_id = -1;
      pv_multiple_files(&p, p.ac, p.av);
    }
  SDL_WaitThread(mouse_thread, NULL);
  SDL_WaitThread(keyboard_thread, NULL);
}
