/*
** scroll.c for pv in /home/saf/pv
** 
** Made by Stephan Ferraro
** Login   <saf@xy1.org>
** 
** Started on  Tue Dec 30 02:53:38 2003 Stephan Ferraro
** Last update Fri May 14 18:02:55 2004 Debian User
** 
** This program is free software; you can redistribute it and/or
** modify it under the terms of the GNU Library General Public
** License as published by the Free Software Foundation; either
** version 2 of the License, or (at your option) any later version.
**
** This library is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
** Library General Public License for more details.
** 
** You should have received a copy of the GNU Library General Public
** License along with this library; if not, write to the Free
** Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include	"pv.h"

/* The code here is a little ugly, unfortunality, I didn't had much time */
/* to reprogramm it beautifuller. */
int		init_scroll(t_pv *p)
{
  memset(&(p->scroll_rect), 0, sizeof(SDL_Rect));
  return (0);
}

int		check_scroll_direction(t_pv *p, int direction)
{
  int		img_w;
  int		img_h;

  if (p->zoom_activated) /* no limit in scrolling while zoom mode */
    return (1);
  
  if (p->zoom == 100)
    {
      if (p->rotate == 90 || p->rotate == 270)
	{
	  img_w = p->img_file->h;
	  img_h = p->img_file->w;
	}
      else
	{
	  img_w = p->img_file->w;
	  img_h = p->img_file->h;
	}
    }
  else
    {
      if (p->rotate == 90 || p->rotate == 270)
	{
	  img_w = p->zoom_h;
	  img_h = p->zoom_w;
	}
      else
	{
	  img_w = p->zoom_w;
	  img_h = p->zoom_h;
	}
    }

  if (direction == PV_DIR_UP || direction == PV_DIR_DOWN)
    {
      if (img_h > p->win_h)
	{
	  if (direction == PV_DIR_DOWN)
	    {
	      if ((p->win_h - p->scroll_rect.y + SCROLL_SIZE) < img_h)
		{
		  return (1);
		}
	    }
	  else
	    {
	      if (p->scroll_rect.y + SCROLL_SIZE < 0)
		{
		  return (1);
		}  
	    }
	  if (direction == PV_DIR_UP)
	    p->scroll_rect.y = 0;
	  else
	    p->scroll_rect.y = p->win_h - img_h;
	  aff_current_file(p);
	}
    }
  else
    {
      if (img_w > p->win_w)
	{
	  if (direction == PV_DIR_RIGHT)
	    {
	      if ((p->win_w - p->scroll_rect.x + SCROLL_SIZE) < img_w)
		{
		  return (1);
		}
	    }
	  else
	    {
	      if (p->scroll_rect.x + SCROLL_SIZE < 0)
		{
		  return (1);
		}  
	    }
	  if (direction == PV_DIR_RIGHT)
	    p->scroll_rect.x = p->win_w - img_w;
	  else
	    p->scroll_rect.x = 0;
	  aff_current_file(p);
	}
    }
  return (0);
}

int		press_down(t_pv *p)
{
  if (check_scroll_direction(p, PV_DIR_DOWN))
    p->key_press_dir_y = -1;
  return (0);
}

int		press_up(t_pv *p)
{
  p->key_press_dir_y = 1;
  return (0);
}

int		press_right(t_pv *p)
{
  p->key_press_dir_x = 1;
  return (0);
}

int		press_left(t_pv *p)
{
  p->key_press_dir_x = -1;
  return (0);
}

int		unpress_down(t_pv *p)
{
  p->key_press_dir_y = 0;
  return (0);
}

int		unpress_up(t_pv *p)
{
  p->key_press_dir_y = 0;
  return (0);
}

int		unpress_right(t_pv *p)
{
  p->key_press_dir_x = 0;
  return (0);
}

int		unpress_left(t_pv *p)
{
  p->key_press_dir_x = 0;
  return (0);
}

int		aff_scroll_down(t_pv *p)
{
  if (check_scroll_direction(p, PV_DIR_DOWN))
    {
      p->scroll_rect.y -= SCROLL_SIZE;
      p->scroll_now = 1;
      aff_current_file(p);
      p->scroll_now = 0;
    }
  else
    unpress_down(p);
  return (0);
}

int		aff_scroll_up(t_pv *p)
{
  if (check_scroll_direction(p, PV_DIR_UP))
    {
      p->scroll_rect.y += SCROLL_SIZE;
      p->scroll_now = 1;
      aff_current_file(p);
      p->scroll_now = 0;
    }
  else
    unpress_up(p);
  return (0);
}

int		aff_scroll_left(t_pv *p)
{
  if (check_scroll_direction(p, PV_DIR_LEFT) || p->zoom != 100)
    {
      p->scroll_rect.x += SCROLL_SIZE;
      p->scroll_now = 1;
      aff_current_file(p);
      p->scroll_now = 0;
    }
  else
    unpress_left(p);
  return (0);
}

int		aff_scroll_right(t_pv *p)
{
  if (check_scroll_direction(p, PV_DIR_RIGHT) || p->zoom != 100)
    {
      p->scroll_rect.x -= SCROLL_SIZE;
      p->scroll_now = 1;
      aff_current_file(p);
      p->scroll_now = 0;
    }
  else
    unpress_right(p);
  return (0);
}

int		aff_scroll_by_mouse(t_pv *p)
{
  int		img_w;
  int		img_h;

  if (p->rotate == 90 || p->rotate == 270)
    {
      img_w = p->img_file->h;
      img_h = p->img_file->w;
    }
  else
    {
      img_w = p->img_file->w;
      img_h = p->img_file->h;
    }
  if (img_w > p->win_w)
    {
      p->scroll_rect.x += (p->mouse_x - p->mouse_old_x);
      if (p->scroll_rect.x > 0)
	p->scroll_rect.x = 0;
      if (-(p->scroll_rect.x) > (img_w - p->win_w))
	p->scroll_rect.x = -(img_w - p->win_w);
    }
  if (img_h > p->win_h)
    {
      p->scroll_rect.y += (p->mouse_y - p->mouse_old_y);
      if (p->scroll_rect.y < (p->win_h - img_h))
	p->scroll_rect.y = p->win_h - img_h;
      if (p->scroll_rect.y > 0)
	p->scroll_rect.y = 0;
    }
  aff_current_file(p);
  return (0);
}

int		scroll_test_if_key_press(t_pv *p)
{
  if (p->key_press_dir_y < 0)
    return (aff_scroll_down(p));
  if (p->key_press_dir_y > 0)
    return (aff_scroll_up(p));
  if (p->key_press_dir_x > 0)
    return (aff_scroll_right(p));
  if (p->key_press_dir_x < 0)
    return (aff_scroll_left(p));
  return (-1);
}
