/*
** zoom.c for pv in /home/saf/pv/src
** 
** Made by Stephan Ferraro
** Login   <saf@xy1.org>
** 
** Started on  Sun Feb 15 03:39:32 2004 Stephan Ferraro
** Last update Mon Jun 14 18:28:57 2004 Stephan Ferraro
** 
** This program is free software; you can redistribute it and/or
** modify it under the terms of the GNU Library General Public
** License as published by the Free Software Foundation; either
** version 2 of the License, or (at your option) any later version.
**
** This library is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
** Library General Public License for more details.
** 
** You should have received a copy of the GNU Library General Public
** License along with this library; if not, write to the Free
** Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include	"pv.h"

int		press_zoom_in(t_pv *p)
{
  p->key_zoom = 1;
  return (0);
}

int		press_zoom_out(t_pv *p)
{
  p->key_zoom = -1;
  return (0);
}

int		unpress_stop_zoom(t_pv *p)
{
  p->wait_zoom_cyl = WAIT_FIRST_ZOOM;
  p->wait_zoom = 0;
  p->key_zoom = 0;
  return (0);
}

int		zoom_out(t_pv *p)
{
  int		tmp;
  int		tmp2;

  if (!p->zoom_activated)
    p->zoom_activated = 1;
  tmp2 = p->zoom;
  tmp = p->zoom - ((p->zoom / 10) + 10);
  p->zoom = tmp;
  get_zoom_ratio(p, p->win_w, p->win_h, p->img_file->w, p->img_file->h);
  if (p->real_zoom < 0.0)
   p->zoom = tmp2;
  aff_current_file(p);
  return (0);
}

int		zoom_in(t_pv *p)
{
  if (!p->zoom_activated)
    p->zoom_activated = 1;
  p->zoom = p->zoom + (p->zoom / 10) + 10;
  aff_current_file(p);
  return (0);
}

int		zoom_if_key_press(t_pv *p)
{
  if (p->key_zoom != 0) /* Only if a key is pressed, proceed. */
    {
      if (p->wait_zoom_cyl && p->wait_zoom)
	p->wait_zoom_cyl--;
      else
	{
	  if (p->wait_zoom_cyl > 0)
	    p->wait_zoom = 1;
	  if (p->key_zoom == 1)
	    return (zoom_in(p));
	  if (p->key_zoom == -1)
	    return (zoom_out(p));
	}
    }
  return (0);
}
